## mudlet 3.7.1

=== CMakeLists.txt ===
############################################################################
#    Copyright (C) 2014 by Ahmed Charles - acharles@outlook.com            #
#    Copyright (C) 2015-2017 by Stephen Lyons - slysven@virginmedia.com    #
#                                                                          #
#    This program is free software; you can redistribute it and/or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################

# Should be called before PROJECT.
cmake_minimum_required(VERSION 3.1)

project(mudlet)

if(CMAKE_CONFIGURATION_TYPES)
  add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND}
                    --force-new-ctest-process --output-on-failure
                    --build-config "$<CONFIGURATION>")
else()
  add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND}
                    --force-new-ctest-process --output-on-failure)
endif()

enable_testing()

if(POLICY CMP0020)
  cmake_policy(SET CMP0020 NEW)
endif()

if(WIN32)
  set(APP_TARGET mudlet.exe)
elseif(APPLE)
  set(APP_TARGET Mudlet)
else()
  set(APP_TARGET mudlet)
endif()

# APP_BUILD should only be empty/null in official "release" builds,
# developers may like to set the MUDLET_VERSION_BUILD environment variable to
# their user and branch names to make it easier to tell different builds apart!
#
# Changing this pair of values affects: ctelnet.cpp, main.cpp, mudlet.cpp
# dlgAboutDialog.cpp and TLuaInterpreter.cpp.  It will not necessarily cause
# those files to be automatically rebuilt so you may need to 'touch' those files if
# the variables are changed and you are not doing a full, clean, rebuild!
# Use APP_VERSION, APP_BUILD and APP_TARGET defines in the source code if needed.
# IMPORTANT:
# To insure consistency please ensure the SAME of the first two values are also
# assigned to the "VERSION" and "BUILD" variables in the native qmake project
# file, which is NOW called: ./src/mudlet.pro
set(APP_VERSION 3.7.1)
if(DEFINED ENV{MUDLET_VERSION_BUILD} AND NOT $ENV{MUDLET_VERSION_BUILD} STREQUAL "")
  SET(APP_BUILD $ENV{MUDLET_VERSION_BUILD})
else()
  set(APP_BUILD "")
endif()

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})

# Enable the built-in updater by default on the three main supported OS
# unless environmental variable WITH_UPDATER is already defined and set to "NO"
# (case insensitive).
# Linux packagers will find it useful to do this since package managers are
# responsible for updates there. Automatically exclude the update stuff from
# other OSs such as FreeBSD and Cygwin because if they ever get finished they
# have their own packaging system - and we do not support updating them.
# Note: WITH_UPDATER is an environmental value/variable (could be a number, a
#           string, something else or not even exist).
#       UPDATER_TEST and USE_UPDATER are cmake variables (possibly a string and
#           NO(false) or YES(true) respectively).
#       INCLUDE_UPDATER is a C preprocessor symbol.
set(UPDATER_TEST $ENV{WITH_UPDATER})
if((CMAKE_SYSTEM_NAME STREQUAL "Linux") OR (CMAKE_SYSTEM_NAME STREQUAL "Windows") OR (CMAKE_SYSTEM_NAME STREQUAL "Darwin"))
  # We are on one of the supported platforms
  if(DEFINED UPDATER_TEST)
    string(TOUPPER ${UPDATER_TEST} UPDATER_TEST)
    if(UPDATER_TEST STREQUAL "NO")
      # The specific tested for value was seen so set the option "no don't
      # include the updater"
      option(USE_UPDATER "Include libraries and code to allow release versions to be updated on demand" OFF)
    else()
      # Any other value was seen so ignore it and set "yes, include the updater"
      option(USE_UPDATER "Include libraries and code to allow release versions to be updated on demand" ON)
    endif()
  else()
    # An environmental variable not detected, apply platform default of "yes, include the updater"
    option(USE_UPDATER "Include libraries and code to allow release versions to be updated on demand" ON)
  endif()
else()
  # Option not available for other platforms
  set(USE_UPDATER NO)
endif()

if(APPLE)
  # Needed (just) on MacOs as an #include in luazip.h:
  add_subdirectory(3rdparty/luazip)
endif()

if(NOT EXISTS "${CMAKE_HOME_DIRECTORY}/3rdparty/edbee-lib/CMakeLists.txt")
  # The above CMakeList.txt is the top level one - we actually use the one
  # another level down in 3rdparty/edbee-lib/edbee-lib/CMakeLists.txt
  message(STATUS "git submodule for required edbee-lib editor widget missing from source code, will attempt to get it...")
  execute_process(COMMAND git submodule update --init 3rdparty/edbee-lib
    TIMEOUT 30
    WORKING_DIRECTORY ${CMAKE_HOME_DIRECTORY}
    OUTPUT_VARIABLE output_text
    ERROR_VARIABLE error_text)
  if(output_text OR error_text)
    message(STATUS ${output_text} ${error_text})
  endif()
endif()

if(NOT EXISTS "${CMAKE_HOME_DIRECTORY}/3rdparty/lcf/lcf-scm-1.rockspec")
  message(STATUS "git submodule for required lua code formatter source code missing, will attempt to get it...")
  execute_process(COMMAND git submodule update --init 3rdparty/lcf
    TIMEOUT 30
    WORKING_DIRECTORY ${CMAKE_HOME_DIRECTORY}
    OUTPUT_VARIABLE output_text
    ERROR_VARIABLE error_text)
  if(output_text OR error_text)
    message(STATUS ${output_text} ${error_text})
  endif()
endif()

if(USE_UPDATER)
  if(NOT EXISTS "${CMAKE_HOME_DIRECTORY}/3rdparty/dblsqd/CMakeLists.txt")
    message(STATUS "git submodule for optional but wanted DBLSQD updater missing from source code, will attempt to get it...")
    execute_process(COMMAND git submodule update --init 3rdparty/dblsqd
      TIMEOUT 30
      WORKING_DIRECTORY ${CMAKE_HOME_DIRECTORY}
      OUTPUT_VARIABLE output_text
      ERROR_VARIABLE error_text)
    if(output_text OR error_text)
      message(STATUS ${output_text} ${error_text})
    endif()
  endif()
endif()

if(APPLE)
  if(USE_UPDATER)
    if(NOT EXISTS "${CMAKE_HOME_DIRECTORY}/3rdparty/sparkle-glue/CMakeLists.txt")
      message(STATUS "git submodule for optional but wanted Sparkle glue for updater missing from source code, will attempt to get it...")
      execute_process(COMMAND git submodule update --init 3rdparty/sparkle-glue
        TIMEOUT 30
        WORKING_DIRECTORY ${CMAKE_HOME_DIRECTORY}
        OUTPUT_VARIABLE output_text
        ERROR_VARIABLE error_text)
      if(output_text OR error_text)
        message(STATUS ${output_text} ${error_text})
      endif()
    endif()
  endif()
endif()

if(EXISTS "${CMAKE_HOME_DIRECTORY}/3rdparty/edbee-lib/CMakeLists.txt")
  add_subdirectory(3rdparty/edbee-lib/edbee-lib)
elseif()
  message(FATAL_ERROR "Cannot locate edbee-lib editor widget submodule source code, build abandoned!")
endif()

file(GLOB_RECURSE lua_files RELATIVE "${CMAKE_HOME_DIRECTORY}/src/mudlet-lua/lua/" "${CMAKE_HOME_DIRECTORY}/src/mudlet-lua/lua/*.lua")
list(LENGTH lua_files lua_file_count)
if(lua_file_count EQUAL 25)
  message(STATUS "Found Mudlet & Geyser lua files")
else()
  message(WARNING "Found ${lua_file_count} Mudlet & Geyser lua files but 25 were expected:")
  foreach(lua_file ${lua_files})
    message(STATUS "    ${lua_file}")
  endforeach(lua_file)
endif()

if(EXISTS "${CMAKE_HOME_DIRECTORY}/3rdparty/lcf/lcf-scm-1.rockspec")
  file(GLOB_RECURSE lcf_files RELATIVE "${CMAKE_HOME_DIRECTORY}/3rdparty/" "${CMAKE_HOME_DIRECTORY}/3rdparty/lcf/*")
  list(REMOVE_ITEM lcf_files "lcf/.git")
  list(LENGTH lcf_files lcf_file_count)
  if(lcf_file_count EQUAL 288)
    message(STATUS "Found Lua Code Formatter files")
  else()
    message(WARNING "Found ${lcf_file_count} Lua Code Formatter files but 288 were expected:")
    foreach(lcf_file ${lcf_files})
      message(STATUS "    ${lcf_file}")
    endforeach(lcf_file)
  endif()
elseif()
  message(FATAL_ERROR "Cannot locate lua code formatter submodule source code, build abandoned!")
endif()

if(USE_UPDATER)
  if(EXISTS "${CMAKE_HOME_DIRECTORY}/3rdparty/dblsqd/CMakeLists.txt")
    add_subdirectory(3rdparty/dblsqd)
    add_definitions(-DINCLUDE_UPDATER)
  else()
    message(FATAL_ERROR "Cannot locate DBLSQD updater submodule source code, build abandoned!")
  endif()

  if(APPLE)
    if(EXISTS "${CMAKE_HOME_DIRECTORY}/3rdparty/sparkle-glue/CMakeLists.txt")
      add_subdirectory(3rdparty/sparkle-glue)
    else()
      message(FATAL_ERROR "Cannot locate Sparkle glue for updater submodule source code, build abandoned!")
    endif()

    if(NOT EXISTS "${CMAKE_HOME_DIRECTORY}/3rdparty/cocoapods/Pods/Sparkle")
      message(STATUS "Sparkle CocoaPod is missing, running 'pod install' to get it...")
      execute_process(TIMEOUT 30
        WORKING_DIRECTORY "${CMAKE_HOME_DIRECTORY}/3rdparty/cocoapods"
        COMMAND pod install)
    endif()
  endif()
endif()


find_program(CCACHE_FOUND ccache)
if(CCACHE_FOUND)
  set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
  set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
endif(CCACHE_FOUND)

add_subdirectory(src)
add_subdirectory(3rdparty/communi)
add_subdirectory(3rdparty/lua_yajl)

=== 3rdparty/communi/CMakeLists.txt ===
############################################################################
# Communi                                                                  #
#                                                                          #
#    Copyright (C) 2014-2017 by Ahmed Charles - acharles@outlook.com       #
#                                                                          #
#    This program is free software; you can redistribute it and/or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################

if(POLICY CMP0020)
  cmake_policy(SET CMP0020 NEW)
endif()

project(communi)

find_package(Qt5Core REQUIRED)
find_package(Qt5Network REQUIRED)

include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}/include/IrcCore
  ${CMAKE_CURRENT_SOURCE_DIR}/include/IrcModel
  ${CMAKE_CURRENT_SOURCE_DIR}/include/IrcUtil
)

set(SRCS
  src/core/irc.cpp
  src/core/irccommand.cpp
  src/core/ircconnection.cpp
  src/core/irccore.cpp
  src/core/ircfilter.cpp
  src/core/ircmessage.cpp
  src/core/ircmessage_p.cpp
  src/core/ircmessagecomposer.cpp
  src/core/ircmessagedecoder.cpp
  src/core/ircmessagedecoder_none.cpp
  src/core/ircnetwork.cpp
  src/core/ircprotocol.cpp
  src/3rdparty/mozilla/rdf_utils.c
  src/model/ircbuffer.cpp
  src/model/ircbuffermodel.cpp
  src/model/ircchannel.cpp
  src/model/ircmodel.cpp
  src/model/ircuser.cpp
  src/model/ircusermodel.cpp
  src/util/irccommandparser.cpp
  src/util/irccommandqueue.cpp
  src/util/irccompleter.cpp
  src/util/irclagtimer.cpp
  src/util/ircpalette.cpp
  src/util/irctextformat.cpp
  src/util/irctoken.cpp
  src/util/ircutil.cpp
)
set(HDRS
  include/IrcCore/irccommand_p.h
  include/IrcCore/ircconnection_p.h
  include/IrcCore/ircdebug_p.h
  include/IrcCore/ircmessage_p.h
  include/IrcCore/ircmessagecomposer_p.h
  include/IrcCore/ircmessagedecoder_p.h
  include/IrcCore/ircnetwork_p.h
  include/IrcModel/ircuser_p.h
  include/IrcModel/ircbuffer_p.h
  include/IrcModel/ircchannel_p.h
  include/IrcModel/ircusermodel_p.h
  include/IrcModel/ircbuffermodel_p.h
  include/IrcUtil/irctoken_p.h
  include/IrcUtil/irclagtimer_p.h
  include/IrcUtil/irccommandqueue_p.h
  include/IrcUtil/irccommandparser_p.h
)
set(MOC_HDRS
  include/IrcCore/irc.h
  include/IrcCore/irccommand.h
  include/IrcCore/ircconnection.h
  include/IrcCore/ircmessage.h
  include/IrcCore/ircnetwork.h
  include/IrcCore/ircprotocol.h
  include/IrcModel/ircbuffer.h
  include/IrcModel/ircbuffermodel.h
  include/IrcModel/ircchannel.h
  include/IrcModel/ircmodel.h
  include/IrcModel/ircuser.h
  include/IrcModel/ircusermodel.h
  include/IrcUtil/irccommandparser.h
  include/IrcUtil/irccommandqueue.h
  include/IrcUtil/irccompleter.h
  include/IrcUtil/irclagtimer.h
  include/IrcUtil/ircpalette.h
  include/IrcUtil/irctextformat.h
  include/IrcUtil/ircutil.h
)
set(PUB_HDRS
  ${MOC_HDRS}
  include/IrcCore/irccore.h
  include/IrcCore/ircfilter.h
  include/IrcCore/ircglobal.h
  include/IrcCore/Irc
  include/IrcCore/IrcCommand
  include/IrcCore/IrcCommandFilter
  include/IrcCore/IrcConnection
  include/IrcCore/IrcCore
  include/IrcCore/IrcGlobal
  include/IrcCore/IrcMessage
  include/IrcCore/IrcMessageFilter
  include/IrcCore/IrcNetwork
  include/IrcCore/IrcProtocol
  include/IrcModel/IrcBuffer
  include/IrcModel/IrcBufferModel
  include/IrcModel/IrcChannel
  include/IrcModel/IrcModel
  include/IrcModel/IrcUser
  include/IrcModel/IrcUserModel
  include/IrcUtil/IrcCommandParser
  include/IrcUtil/IrcCommandQueue
  include/IrcUtil/IrcCompleter
  include/IrcUtil/IrcLagTimer
  include/IrcUtil/IrcPalette
  include/IrcUtil/IrcTextFormat
  include/IrcUtil/IrcUtil
)

QT5_GENERATE_MOC(include/IrcCore/irc.h ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_irc.cpp)
QT5_GENERATE_MOC(include/IrcCore/irccommand.h ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_irccommand.cpp)
QT5_GENERATE_MOC(include/IrcCore/ircconnection.h ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_ircconnection.cpp)
QT5_GENERATE_MOC(include/IrcCore/ircmessage.h ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_ircmessage.cpp)
QT5_GENERATE_MOC(include/IrcCore/ircmessagecomposer_p.h ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_ircmessagecomposer_p.cpp)
QT5_GENERATE_MOC(include/IrcCore/ircnetwork.h ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_ircnetwork.cpp)
QT5_GENERATE_MOC(include/IrcCore/ircprotocol.h ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_ircprotocol.cpp)
QT5_GENERATE_MOC(include/IrcModel/ircusermodel.h ${CMAKE_CURRENT_BINARY_DIR}/IrcModel/moc_ircusermodel.cpp)
QT5_GENERATE_MOC(include/IrcModel/ircchannel.h ${CMAKE_CURRENT_BINARY_DIR}/IrcModel/moc_ircchannel.cpp)
QT5_GENERATE_MOC(include/IrcModel/ircbuffer.h ${CMAKE_CURRENT_BINARY_DIR}/IrcModel/moc_ircbuffer.cpp)
QT5_GENERATE_MOC(include/IrcModel/ircbuffermodel_p.h ${CMAKE_CURRENT_BINARY_DIR}/IrcModel/moc_ircbuffermodel_p.cpp)
QT5_GENERATE_MOC(include/IrcModel/ircbuffermodel.h ${CMAKE_CURRENT_BINARY_DIR}/IrcModel/moc_ircbuffermodel.cpp)
QT5_GENERATE_MOC(include/IrcModel/ircuser.h ${CMAKE_CURRENT_BINARY_DIR}/IrcModel/moc_ircuser.cpp)
QT5_GENERATE_MOC(include/IrcModel/ircusermodel.h ${CMAKE_CURRENT_BINARY_DIR}/IrcModel/moc_ircusermodel.cpp)
QT5_GENERATE_MOC(include/IrcUtil/irccompleter.h ${CMAKE_CURRENT_BINARY_DIR}/IrcUtil/moc_irccompleter.cpp)
QT5_GENERATE_MOC(include/IrcUtil/irccommandparser.h ${CMAKE_CURRENT_BINARY_DIR}/IrcUtil/moc_irccommandparser.cpp)
QT5_GENERATE_MOC(include/IrcUtil/irccommandqueue.h ${CMAKE_CURRENT_BINARY_DIR}/IrcUtil/moc_irccommandqueue.cpp)
QT5_GENERATE_MOC(include/IrcUtil/irccommandqueue_p.h ${CMAKE_CURRENT_BINARY_DIR}/IrcUtil/moc_irccommandqueue_p.cpp)
QT5_GENERATE_MOC(include/IrcUtil/irclagtimer.h ${CMAKE_CURRENT_BINARY_DIR}/IrcUtil/moc_irclagtimer.cpp)
QT5_GENERATE_MOC(include/IrcUtil/irclagtimer_p.h ${CMAKE_CURRENT_BINARY_DIR}/IrcUtil/moc_irclagtimer_p.cpp)
QT5_GENERATE_MOC(include/IrcUtil/irctextformat.h ${CMAKE_CURRENT_BINARY_DIR}/IrcUtil/moc_irctextformat.cpp)
QT5_GENERATE_MOC(include/IrcUtil/ircpalette.h ${CMAKE_CURRENT_BINARY_DIR}/IrcUtil/moc_ircpalette.cpp)

set_property(SOURCE src/core/irc.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_irc.cpp)
set_property(SOURCE src/core/irccommand.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_irccommand.cpp)
set_property(SOURCE src/core/ircconnection.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_ircconnection.cpp)
set_property(SOURCE src/core/ircmessage.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_ircmessage.cpp)
set_property(SOURCE src/core/ircmessagecomposer.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_ircmessagecomposer_p.cpp)
set_property(SOURCE src/core/ircnetwork.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_ircnetwork.cpp)
set_property(SOURCE src/core/ircprotocol.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcCore/moc_ircprotocol.cpp)
set_property(SOURCE src/model/ircusermodel.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcModel/moc_ircusermodel.cpp)
set_property(SOURCE src/model/ircchannel.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcModel/moc_ircchannel.cpp)
set_property(SOURCE src/model/ircbuffer.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcModel/moc_ircbuffer.cpp)
set_property(SOURCE src/model/ircbuffermodel.cpp 
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcModel/moc_ircbuffermodel.cpp)
set_property(SOURCE src/model/ircbuffermodel.cpp 
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcModel/moc_ircbuffermodel_p.cpp)
set_property(SOURCE src/model/ircuser.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcModel/moc_ircuser.cpp)
set_property(SOURCE src/model/ircusermodel.cpp 
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcModel/moc_ircusermodel.cpp)
set_property(SOURCE src/util/irccompleter.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcUtil/moc_irccompleter.cpp)
set_property(SOURCE src/util/irccommandparser.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcUtil/moc_irccommandparser.cpp)
set_property(SOURCE src/util/irccommandqueue.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcUtil/moc_irccommandqueue.cpp)
set_property(SOURCE src/util/irccommandqueue.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcUtil/moc_irccommandqueue_p.cpp)
set_property(SOURCE src/util/irclagtimer.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcUtil/moc_irclagtimer.cpp)
set_property(SOURCE src/util/irclagtimer.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcUtil/moc_irclagtimer_p.cpp)
set_property(SOURCE src/util/irctextformat.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcUtil/moc_irctextformat.cpp)
set_property(SOURCE src/util/ircpalette.cpp
  APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/IrcUtil/moc_ircpalette.cpp)

add_library(communi STATIC ${SRCS} ${HDRS} ${PUB_HDRS})

target_link_libraries(communi ${Qt5Core_LIBRARIES} ${Qt5Network_LIBRARIES})

target_include_directories(communi PRIVATE
  ${CMAKE_CURRENT_BINARY_DIR}/IrcCore
  ${CMAKE_CURRENT_BINARY_DIR}/IrcModel
  ${CMAKE_CURRENT_BINARY_DIR}/IrcUtil
)
target_include_directories(communi PUBLIC
  ${Qt5Core_INCLUDE_DIRS}
  ${Qt5Network_INCLUDE_DIRS}
  ${CMAKE_CURRENT_SOURCE_DIR}/include/IrcCore
  ${CMAKE_CURRENT_SOURCE_DIR}/include/IrcModel
  ${CMAKE_CURRENT_SOURCE_DIR}/include/IrcUtil
)

=== 3rdparty/dblsqd/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 3.1)

IF(POLICY CMP0020)
  CMAKE_POLICY(SET CMP0020 NEW)
ENDIF()

PROJECT(dblsqd-sdk-qt)

SET(SOURCES
  dblsqd/release.cpp
  dblsqd/semver.cpp
  dblsqd/update_dialog.cpp
  dblsqd/feed.cpp
)

SET(HEADERS
  dblsqd/release.h
  dblsqd/semver.h
  dblsqd/update_dialog.h
  dblsqd/feed.h
)

FIND_PACKAGE(Qt5Core REQUIRED)
FIND_PACKAGE(Qt5Network REQUIRED)
FIND_PACKAGE(Qt5Widgets REQUIRED)

# Qt 5.7 or greater require C++11 standard. Set this requirement conditionally to lower requirements where possible
IF (Qt5Core_VERSION VERSION_EQUAL 5.7 OR Qt5Core_VERSION VERSION_GREATER 5.7)
  set(CMAKE_CXX_STANDARD 11)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)
ENDIF()

IF(Qt5_POSITION_INDEPENDENT_CODE)
  SET(CMAKE_POSITION_INDEPENDENT_CODE ON)
ENDIF()

# automatically use moc and uic when needed
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)

ADD_DEFINITIONS(
  ${Qt5Core_DEFINITIONS}
  ${Qt5Network_DEFINTIONS}
  ${Qt5Widgets_DEFINTIONS}
)


SET(CMAKE_INCLUDE_CURRENT_DIR ON)
INCLUDE_DIRECTORIES(
  ${Qt5Core_INCLUDE_DIRS}
  ${Qt5Network_INCLUDE_DIRS}
  ${Qt5Widgets_INCLUDE_DIRS}
)

ADD_LIBRARY(dblsqd STATIC
  ${SOURCES} ${HEADERS}
)

# publish the include directories to allow dependent projects to find the needed headers
TARGET_INCLUDE_DIRECTORIES(dblsqd PUBLIC
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${Qt5Core_INCLUDE_DIRS}
  ${Qt5Network_INCLUDE_DIRS}
  ${Qt5Widgets_INCLUDE_DIRS}
# the includes below are needed to find generated uic headers
# see https://gitlab.kitware.com/cmake/cmake/issues/16925
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}/dblsqd_autogen/include
  ${CMAKE_CURRENT_BINARY_DIR}/dblsqd_autogen/include_$<CONFIG>
)

=== 3rdparty/edbee-lib/CMakeLists.txt ===
# Should be called before PROJECT.
CMAKE_MINIMUM_REQUIRED(VERSION 3.1)

PROJECT(edbee)

ADD_SUBDIRECTORY(edbee-lib)
ADD_SUBDIRECTORY(edbee-test)

=== 3rdparty/lua_yajl/CMakeLists.txt ===
project(lua_yajl LANGUAGES C)

find_package(Lua51 REQUIRED)
find_package(YAJL REQUIRED)

add_library(lua_yajl STATIC lua_yajl.c)

target_link_libraries(lua_yajl ${LUA_LIBRARIES} ${YAJL_LIBRARIES})

target_include_directories(lua_yajl PRIVATE
  ${LUA_INCLUDE_DIR}
  ${YAJL_INCLUDE_DIR}
)

=== 3rdparty/luazip/CMakeLists.txt ===
project(luazip LANGUAGES C)

find_package(Lua51 REQUIRED)

# Break each step into a separate command so any status message is output straight away
# The include directory setup for Zip is unusual in that as well as e.g. /usr/include/zip.h
# we need the path to an interal header zipconf.g that it calls for using '<''>'s
# i.e. SYSTEM #include delimiters which are typically located at e.g. /usr/lib/libzip/include/zipconf.h
# and using pkg-config is the recommended way to get the details.
# Spotted recommendation to use pkg-config here https://github.com/Homebrew/homebrew/issues/13390
find_package(PkgConfig)
if(NOT(PKG_CONFIG_FOUND))
  message(WARNING "Unable to use pkg_config - will possibly fail to find/use Zip library...")
endif()

if(PKG_CONFIG_FOUND)
  # Examining Homebrew (for MacOs) for libzzip:
  # https://bintray.com/homebrew/bottles/libzzip found that they use pkg-config
  # So use that to try and find what we want
  PKG_SEARCH_MODULE(PC_ZZIPLIB zziplib libzzip zzip)
  if(PC_ZZIPLIB_FOUND)
    if(PC_ZZIPLIB_zziplib_FOUND)
      message(STATUS "Using pkg_config, found \"zziplib\" version: ${PC_ZZIPLIB_zziplib_VERSION} with:")
    elseif(PC_ZZIPLIB_libzzip_FOUND)
      message(STATUS "Using pkg_config, found \"libzzip\" version: ${PC_ZZIPLIB_libzzip_VERSION} with:")
    elseif(PC_ZZIPLIB_zzip_FOUND)
      message(STATUS "Using pkg_config, found \"zzip\" version: ${PC_ZZIPLIB_zzip_VERSION} with:")
    else()
      message(STATUS "Using pkg_config, found Zzip version: ${PC_ZZIPLIB_VERSION} with:")
    endif()
    message(STATUS "  include directory(ies), ZZIPLIB_INCLUDE_DIRS: ${PC_ZZIPLIB_INCLUDE_DIRS} .")
    message(STATUS "  library(ies): ZZIPLIB_LIBRARY_DIRS: ${PC_ZZIPLIB_LIBRARY_DIRS}; ZZIPLIB_LIBDIR: ${PC_ZZIPLIB_LIBDIR}. ")
  elseif()
    message(WARNING "Using pkg_config, failed to find any version of Zziplib library!")
  endif()
endif()

if(NOT(PC_ZZIPLIB_FOUND))
  find_package(ZZIPLIB)
endif()
if(NOT((ZZIPLIB_FOUND) OR (PC_ZZIPLIB_FOUND) OR (PC_ZZIPLIB_zziplib_FOUND) OR (PC_ZZIPLIB_libzzip_FOUND) OR (PC_ZZIPLIB_zzip_FOUND)))
  message(WARNING "Failed to find any trace of zziplib (or zzip or libzzip)\n- so will not be able to build the (internal version for Mac builds) of the lua zip module that Mudlet needs.")
endif()

add_library(luazip INTERFACE)

target_link_libraries(luazip INTERFACE ${LUA_LIBRARIES})

if(PC_ZZIPLIB_FOUND)
  target_link_libraries(luazip INTERFACE ${PC_ZZIPLIB_LIBRARIES})
else()
  target_link_libraries(luazip INTERFACE ${ZZIPLIB_LIBRARIES})
endif()

target_include_directories(luazip INTERFACE ${CMAKE_CURRENT_SOURCE_DIR} ${LUA_INCLUDE_DIR})

if(PC_ZZIPLIB_FOUND)
  target_include_directories(luazip INTERFACE ${PC_ZZIPLIB_INCLUDE_DIRS})
else()
  target_include_directories(luazip INTERFACE ${ZZIPLIB_INCLUDE_DIRS})
endif()

=== 3rdparty/sparkle-glue/CMakeLists.txt ===
############################################################################
#    Copyright (C) 2017 by Vadim Peretokin - vperetokin@gmail.com          #
#    Copyright (C) 2017 by Florian Scheel - keneanung@googlemail.com       #
#                                                                          #
#    This program is free software; you can redistribute it and/or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################

CMAKE_MINIMUM_REQUIRED(VERSION 3.1)

IF(POLICY CMP0020)
  CMAKE_POLICY(SET CMP0020 NEW)
ENDIF()

PROJECT(cocoa-qt-glue)

set(HEADER_FILES
  SparkleAutoUpdater.h
  CocoaInitializer.h
  AutoUpdater.h
)
set(SOURCE_FILES
  SparkleAutoUpdater.mm
  CocoaInitializer.mm
  AutoUpdater.cpp
)

FIND_PACKAGE(Qt5Core REQUIRED)
FIND_PACKAGE(Qt5Widgets REQUIRED)

# Qt 5.7 or greater requires C++11 standard. Set this requirement conditionally to lower requirements where possible
IF (Qt5Core_VERSION VERSION_EQUAL 5.7 OR Qt5Core_VERSION VERSION_GREATER 5.7)
  set(CMAKE_CXX_STANDARD 11)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)
ENDIF()

IF(Qt5_POSITION_INDEPENDENT_CODE)
  SET(CMAKE_POSITION_INDEPENDENT_CODE ON)
ENDIF()

ADD_DEFINITIONS(
  ${Qt5Core_DEFINITIONS}
  ${Qt5Widgets_DEFINTIONS}
)


SET(CMAKE_INCLUDE_CURRENT_DIR ON)
INCLUDE_DIRECTORIES(
  ${Qt5Core_INCLUDE_DIRS}
  ${Qt5Widgets_INCLUDE_DIRS}
)

add_library(
  cocoa-qt-glue
  STATIC
  ${HEADER_FILES}
  ${SOURCE_FILES}
)

SET(CMAKE_CXX_FLAGS "-F${CMAKE_CURRENT_SOURCE_DIR}/../cocoapods/Pods/Sparkle")

target_link_libraries( cocoa-qt-glue
  "-framework Sparkle"
  "-framework AppKit"
)

=== 3rdparty/edbee-lib/edbee-lib/CMakeLists.txt ===
# Should be called before PROJECT.
CMAKE_MINIMUM_REQUIRED(VERSION 3.1)

IF(POLICY CMP0020)
  CMAKE_POLICY(SET CMP0020 NEW)
ENDIF()

PROJECT(edbee-lib)

SET(SOURCES
   edbee/util/mem/debug_new.cpp
   edbee/util/mem/debug_allocs.cpp
   edbee/util/simpleprofiler.cpp
   edbee/util/textcodecdetector.cpp
   edbee/util/lineending.cpp
   edbee/texteditorwidget.cpp
   edbee/views/textrenderer.cpp
   edbee/models/textdocument.cpp
   edbee/models/chardocument/chartextdocument.cpp
   edbee/models/texteditorconfig.cpp
   edbee/models/texteditorkeymap.cpp
   edbee/models/textundostack.cpp
   edbee/views/textcaretcache.cpp
   edbee/models/textlexer.cpp
   edbee/models/textrange.cpp
   edbee/views/textselection.cpp
   edbee/models/textdocumentscopes.cpp
   edbee/lexers/grammartextlexer.cpp
   edbee/util/gapvector.h
   edbee/util/lineoffsetvector.cpp
   edbee/models/textlinedata.cpp
   edbee/models/textbuffer.cpp
   edbee/models/chardocument/chartextbuffer.cpp
   edbee/texteditorcontroller.cpp
   edbee/texteditorcommand.cpp
   edbee/commands/selectioncommand.cpp
   edbee/commands/undocommand.cpp
   edbee/commands/redocommand.cpp
   edbee/commands/replaceselectioncommand.cpp
   edbee/commands/copycommand.cpp
   edbee/commands/cutcommand.cpp
   edbee/commands/pastecommand.cpp
   edbee/io/textdocumentserializer.cpp
   edbee/util/test.cpp
   edbee/util/textcodec.cpp
   edbee/io/tmlanguageparser.cpp
   edbee/commands/debugcommand.cpp
   edbee/util/regexp.cpp
   edbee/io/tmthemeparser.cpp
   edbee/io/baseplistparser.cpp
   edbee/io/jsonparser.cpp
   edbee/models/textgrammar.cpp
   edbee/models/texteditorcommandmap.cpp
	 edbee/views/components/texteditorautocompletecomponent.cpp
   edbee/views/components/texteditorcomponent.cpp
   edbee/views/components/texteditorrenderer.cpp
   edbee/views/components/textmargincomponent.cpp
   edbee/views/texttheme.cpp
   edbee/views/texteditorscrollarea.cpp
   edbee/models/textsearcher.cpp
   edbee/commands/findcommand.cpp
   edbee/io/keymapparser.cpp
   edbee/commands/tabcommand.cpp
   edbee/edbee.cpp
   edbee/models/textdocumentfilter.cpp
   edbee/util/cascadingqvariantmap.cpp
   edbee/commands/duplicatecommand.cpp
   edbee/commands/movelinecommand.cpp
   edbee/commands/newlinecommand.cpp
   edbee/util/util.cpp
   edbee/commands/removecommand.cpp
   edbee/models/change.cpp
   edbee/models/changes/abstractrangedchange.cpp
   edbee/models/changes/linedatalistchange.cpp
   edbee/models/changes/linedatachange.cpp
   edbee/models/changes/selectionchange.cpp
   edbee/models/changes/textchange.cpp
   edbee/models/changes/textchangewithcaret.cpp
   edbee/models/changes/mergablechangegroup.cpp
   edbee/commands/commentcommand.cpp
   edbee/util/rangesetlineiterator.cpp
   edbee/models/dynamicvariables.cpp
   edbee/util/rangelineiterator.cpp
   edbee/data/factorykeymap.cpp
   edbee/data/factorycommandmap.cpp
   edbee/models/textautocompleteprovider.cpp
)

SET(HEADERS
   edbee/util/logging.h
   edbee/util/mem/debug_new.h
   edbee/util/mem/debug_allocs.h
   edbee/util/simpleprofiler.h
   edbee/util/textcodecdetector.h
   edbee/util/lineending.h
   edbee/texteditorwidget.h
   edbee/views/textrenderer.h
   edbee/models/textdocument.h
   edbee/models/chardocument/chartextdocument.h
   edbee/models/texteditorconfig.h
   edbee/models/texteditorkeymap.h
   edbee/models/textundostack.h
   edbee/texteditorcontroller.h
   edbee/views/textcaretcache.h
   edbee/models/textlexer.h
   edbee/models/textrange.h
   edbee/views/textselection.h
   edbee/models/textdocumentscopes.h
   edbee/lexers/grammartextlexer.h
   edbee/util/lineoffsetvector.h
   edbee/models/textlinedata.h
   edbee/models/textbuffer.h
   edbee/models/chardocument/chartextbuffer.h
   edbee/texteditorcommand.h
   edbee/commands/selectioncommand.h
   edbee/commands/undocommand.h
   edbee/commands/redocommand.h
   edbee/commands/replaceselectioncommand.h
   edbee/commands/copycommand.h
   edbee/commands/cutcommand.h
   edbee/commands/pastecommand.h
   edbee/models/textdocumentfilter.h
   edbee/debug.h
   edbee/io/textdocumentserializer.h
   edbee/util/test.h
   edbee/util/textcodec.h
   edbee/io/tmlanguageparser.h
   edbee/commands/debugcommand.h
   edbee/util/regexp.h
   edbee/io/tmthemeparser.h
   edbee/io/baseplistparser.h
   edbee/io/jsonparser.h
   edbee/models/textgrammar.h
   edbee/models/texteditorcommandmap.h
	 edbee/views/components/texteditorautocompletecomponent.h
   edbee/views/components/texteditorcomponent.h
   edbee/views/components/texteditorrenderer.h
   edbee/views/components/textmargincomponent.h
   edbee/views/texttheme.h
   edbee/views/texteditorscrollarea.h
   edbee/models/textsearcher.h
   edbee/commands/findcommand.h
   edbee/io/keymapparser.h
   edbee/commands/tabcommand.h
   edbee/edbee.h
   edbee/util/cascadingqvariantmap.h
   edbee/commands/duplicatecommand.h
   edbee/commands/movelinecommand.h
   edbee/commands/newlinecommand.h
   edbee/util/util.h
   edbee/commands/removecommand.h
   edbee/models/change.h
   edbee/models/changes/abstractrangedchange.h
   edbee/models/changes/linedatalistchange.h
   edbee/models/changes/linedatachange.h
   edbee/models/changes/selectionchange.h
   edbee/models/changes/textchange.h
   edbee/models/changes/textchangewithcaret.h
   edbee/models/changes/mergablechangegroup.h
   edbee/commands/commentcommand.h
   edbee/util/rangesetlineiterator.h
   edbee/models/dynamicvariables.h
   edbee/util/rangelineiterator.h
   edbee/data/factorykeymap.h
   edbee/data/factorycommandmap.h
   edbee/models/textautocompleteprovider.h
)

FIND_PACKAGE(Qt5Core REQUIRED)
FIND_PACKAGE(Qt5UiTools REQUIRED)
FIND_PACKAGE(Qt5Widgets REQUIRED)

IF(Qt5_POSITION_INDEPENDENT_CODE)
  SET(CMAKE_POSITION_INDEPENDENT_CODE ON)
ENDIF()

set(CMAKE_AUTOMOC ON)

add_subdirectory(../vendor/qslog/ qslog)
add_subdirectory(../vendor/onig/ onig)

ADD_DEFINITIONS(
    ${Qt5Core_DEFINITIONS}
    ${Qt5UiTools_DEFINTIONS}
    ${Qt5Widgets_DEFINTIONS}
)


SET(CMAKE_INCLUDE_CURRENT_DIR ON)
INCLUDE_DIRECTORIES(
    ${Qt5Core_INCLUDE_DIRS}
    ${Qt5UiTools_INCLUDE_DIRS}
    ${Qt5Widgets_INCLUDE_DIRS}
    ${QS_LOG_INCLUDE_DIRS}
    ${ONIG_INCLUDE_DIRS}
)

ADD_LIBRARY(edbee-lib STATIC
  ${SOURCES} ${HEADERS} ${QS_LOG_SOURCES} ${QS_LOG_HEADERS} ${ONIG_SOURCES}
  ${ONIG_HEADERS})

TARGET_INCLUDE_DIRECTORIES(edbee-lib PUBLIC
  ${Qt5Core_INCLUDE_DIRS}
  ${Qt5UiTools_INCLUDE_DIRS}
  ${Qt5Widgets_INCLUDE_DIRS}
  ${QS_LOG_INCLUDE_DIRS}
  ${ONIG_INCLUDE_DIRS}
  ${CMAKE_CURRENT_SOURCE_DIR}
)

SET_PROPERTY(TARGET edbee-lib PROPERTY CXX_STANDARD 11)

=== 3rdparty/edbee-lib/edbee-test/CMakeLists.txt ===
# Should be called before PROJECT.
CMAKE_MINIMUM_REQUIRED(VERSION 3.1)

IF(POLICY CMP0020)
  CMAKE_POLICY(SET CMP0020 NEW)
ENDIF()

PROJECT(edbee-test)

SET(SOURCES
  edbee/commands/replaceselectioncommandtest.cpp 
  edbee/models/textrangetest.cpp 
  edbee/models/textdocumenttest.cpp 
  edbee/models/textbuffertest.cpp 
  edbee/models/textlinedatatest.cpp 
  edbee/util/gapvectortest.cpp 
  edbee/util/lineoffsetvectortest.cpp 
  main.cpp 
  edbee/util/lineendingtest.cpp 
  edbee/textdocumentserializertest.cpp 
  edbee/io/tmlanguageparsertest.cpp 
  edbee/util/regexptest.cpp 
  edbee/models/textdocumentscopestest.cpp 
  edbee/models/textundostacktest.cpp 
  edbee/util/cascadingqvariantmaptest.cpp 
  edbee/models/textsearchertest.cpp 
  edbee/commands/duplicatecommandtest.cpp 
  edbee/commands/newlinecommandtest.cpp 
  edbee/util/utiltest.cpp 
  edbee/lexers/grammartextlexertest.cpp 
  edbee/commands/removecommandtest.cpp 
  edbee/models/changes/linedatalistchangetest.cpp 
  edbee/models/changes/textchangetest.cpp 
  edbee/models/changes/mergablechangegrouptest.cpp 
  edbee/util/rangesetlineiteratortest.cpp 
  edbee/models/dynamicvariablestest.cpp 
  edbee/util/rangelineiteratortest.cpp
  edbee/views/textthememanagertest.cpp    
)

SET(HEADERS
  edbee/commands/replaceselectioncommandtest.h 
  edbee/models/textrangetest.h 
  edbee/models/textdocumenttest.h 
  edbee/models/textbuffertest.h 
  edbee/models/textlinedatatest.h 
  edbee/util/gapvectortest.h 
  edbee/util/lineoffsetvectortest.h 
  edbee/util/lineendingtest.h 
  edbee/textdocumentserializertest.h 
  edbee/io/tmlanguageparsertest.h 
  edbee/util/regexptest.h 
  edbee/models/textdocumentscopestest.h 
  edbee/models/textundostacktest.h 
  edbee/util/cascadingqvariantmaptest.h 
  edbee/models/textsearchertest.h 
  edbee/commands/duplicatecommandtest.h 
  edbee/commands/newlinecommandtest.h 
  edbee/util/utiltest.h 
  edbee/lexers/grammartextlexertest.h 
  edbee/commands/removecommandtest.h 
  edbee/models/changes/linedatalistchangetest.h 
  edbee/models/changes/textchangetest.h 
  edbee/models/changes/mergablechangegrouptest.h 
  edbee/util/rangesetlineiteratortest.h 
  edbee/models/dynamicvariablestest.h 
  edbee/util/rangelineiteratortest.h
  edbee/views/textthememanagertest.h
)

FIND_PACKAGE(Qt5Core REQUIRED)
FIND_PACKAGE(Qt5UiTools REQUIRED)
FIND_PACKAGE(Qt5Widgets REQUIRED)

add_subdirectory(../vendor/qslog/ qslog)

ADD_DEFINITIONS(
    ${Qt5Core_DEFINITIONS}
    ${Qt5UiTools_DEFINTIONS}
    ${Qt5Widgets_DEFINTIONS}
)

SET(CMAKE_INCLUDE_CURRENT_DIR ON)
INCLUDE_DIRECTORIES(
    ${Qt5Core_INCLUDE_DIRS}
    ${Qt5UiTools_INCLUDE_DIRS}
    ${Qt5Widgets_INCLUDE_DIRS}
    ../edbee-lib/
    ${QS_LOG_INCLUDE_DIRS}
)

set(CMAKE_AUTOMOC ON)

ADD_EXECUTABLE(edbee-test
  ${SOURCES} ${HEADERS} ${QS_LOG_SOURCES} ${QS_LOG_HEADERS}
)

TARGET_LINK_LIBRARIES(edbee-test edbee-lib ${Qt5Core_LIBRARIES}
    ${Qt5Widgets_LIBRARIES} ${Qt5UiTools_LIBRARIES})

SET_PROPERTY(TARGET edbee-test PROPERTY CXX_STANDARD 11)

=== 3rdparty/edbee-lib/vendor/onig/CMakeLists.txt ===
IF(NOT WIN32)
  EXECUTE_PROCESS(
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/configure
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  )
ENDIF(NOT WIN32)

SET(ONIG_INCLUDE_DIRS
  ${CMAKE_CURRENT_SOURCE_DIR}/
  ${CMAKE_CURRENT_SOURCE_DIR}/enc/unicode
  PARENT_SCOPE
)

SET(ONIG_SOURCES
           ${CMAKE_CURRENT_SOURCE_DIR}/regcomp.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/regenc.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/regerror.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/regexec.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/regext.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/reggnu.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/regparse.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/regposerr.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/regposix.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/regsyntax.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/regtrav.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/regversion.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/st.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/ascii.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/big5.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/cp949.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/emacs_mule.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/euc_jp.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/euc_kr.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/euc_tw.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/gb18030.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/gbk.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/iso_8859.h 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/iso_8859_1.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/iso_8859_10.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/iso_8859_11.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/iso_8859_13.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/iso_8859_14.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/iso_8859_15.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/iso_8859_16.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/iso_8859_2.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/iso_8859_3.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/iso_8859_4.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/iso_8859_5.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/iso_8859_6.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/iso_8859_7.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/iso_8859_8.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/iso_8859_9.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/koi8_r.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/koi8_u.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/shift_jis.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/unicode.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/us_ascii.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/utf_16be.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/utf_16le.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/utf_32be.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/utf_32le.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/utf_8.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/windows_1250.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/windows_1251.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/windows_1252.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/windows_1253.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/windows_1254.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/windows_1257.c 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/windows_31j.c
           PARENT_SCOPE
)

SET(ONIG_HEADERS
           ${CMAKE_CURRENT_SOURCE_DIR}/config.h 
           ${CMAKE_CURRENT_SOURCE_DIR}/enc/unicode/casefold.h 
           ${CMAKE_CURRENT_SOURCE_DIR}/onigmo.h 
           ${CMAKE_CURRENT_SOURCE_DIR}/onigmognu.h 
           ${CMAKE_CURRENT_SOURCE_DIR}/onigmoposix.h 
           ${CMAKE_CURRENT_SOURCE_DIR}/regenc.h 
           ${CMAKE_CURRENT_SOURCE_DIR}/regint.h 
           ${CMAKE_CURRENT_SOURCE_DIR}/regparse.h 
           ${CMAKE_CURRENT_SOURCE_DIR}/st.h 
           ${CMAKE_CURRENT_SOURCE_DIR}/win32/config.h 
           ${CMAKE_CURRENT_SOURCE_DIR}/config-onig-edbee.h
           PARENT_SCOPE
)

=== 3rdparty/edbee-lib/vendor/qslog/CMakeLists.txt ===
ADD_DEFINITIONS(-DQS_LOG_LINE_NUMBERS_SHORT)

SET(
  QS_LOG_INCLUDE_DIRS
  ${CMAKE_CURRENT_SOURCE_DIR}
  PARENT_SCOPE
)

SET(
  QS_LOG_SOURCES
  ${CMAKE_CURRENT_SOURCE_DIR}/QsLogDest.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/QsLog.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/QsDebugOutput.cpp
  PARENT_SCOPE
)

SET(
  QS_LOG_HEADERS
  ${CMAKE_CURRENT_SOURCE_DIR}/QsLogDest.h
  ${CMAKE_CURRENT_SOURCE_DIR}/QsLog.h
  ${CMAKE_CURRENT_SOURCE_DIR}/QsDebugOutput.h
  ${CMAKE_CURRENT_SOURCE_DIR}/QsLogLevel.h
  PARENT_SCOPE
)

=== debian/changelog ===
mudlet (1:3.7.1-1.1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:50:47 +0100

mudlet (1:3.7.1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Export CCACHE_DIR in debian/rules to prevent a FTBFS because of
    a non-writable cache directory.
  * QTabBar-include.patch: Fix FTBFS by adding the missing include for QTabBar.
    (Closes: #907159)

 -- Markus Koschany <apo@debian.org>  Sun, 09 Dec 2018 15:12:05 +0100

mudlet (1:3.7.1-1) unstable; urgency=medium

  * New upstream release
  * Update to standards 4.1.2

 -- Craig Small <csmall@debian.org>  Sun, 24 Dec 2017 17:49:23 +1100

=== debian/control ===
Source: mudlet
Section: games
Priority: optional
Maintainer: Craig Small <csmall@debian.org>
Build-Depends: debhelper (>= 9), pkg-config,
               libpcre3-dev, zlib1g-dev, libboost-dev, libyajl-dev,
               libhunspell-dev,
               qtbase5-dev, qt5-qmake, qttools5-dev, qtmultimedia5-dev,
               libqt5opengl5-dev,
               liblua5.1-dev, libzip-dev
Standards-Version: 4.1.2
Vcs-Git: git://anonscm.debian.org/collab-maint/mudlet.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/mudlet.git
Homepage: http://www.mudlet.org/

Package: mudlet
Architecture: alpha amd64 arm64 hppa i386 ia64 m32r m68k mips mipsel powerpc ppc64 ppc64el s390 s390x sh3 sh3eb sparc sparc64 x32
Depends: ${shlibs:Depends}, ${misc:Depends},
         lua5.1-rex-pcre, lua5.1-sql-sqlite3,
         lua-filesystem, lua-zip
Suggests: hunspell-en-us
Description: Graphical MUD client with fast lua scripting support
 A completely redesigned MUD (Multi User Dungeon) client that is easy to
 use and customise.  Both power users and plain gamers alike will feel at
 home with Mudlet, without having to waste too much timer figuring out
 how to do something.
 . 
 Mudlet is designed to be very fast and efficient right from the start.
 Its scripting engine is designed to handle thousands of lines under
 one second. The scripting framework uses Lua - a small, fast and
 efficient scripting language.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export QT_SELECT=5
export CCACHE_DIR := $(CURDIR)/debian/ccache

PACKAGE=mudlet
SRC_VERSION:=$(shell dpkg-parsechangelog | sed -ne 's/^Version: \(\([0-9]\+\):\)\?\(.*\)-.*/\3/p')
TARBALL=$(PACKAGE)_$(SRC_VERSION).orig.tar.gz
BUILD_VERSION=$(shell dpkg-parsechangelog -SVersion | sed -e 's/[^-]*/Debian/')

%:
	dh $@ 

override_dh_auto_clean:
	[ ! -f src/Makefile ] || $(MAKE) -C src distclean

override_dh_auto_configure:
	cd src && qmake \
		DATAROOTDIR=/usr/share/games
		QMAKE_CFLAGS_RELEASE="$(shell dpkg-buildflags --get CPPFLAGS) $(shell dpkg-buildflags --get CFLAGS)" \
		QMAKE_CFLAGS_DEBUG="$(shell dpkg-buildflags --get CPPFLAGS) $(shell dpkg-buildflags --get CFLAGS)" \
		QMAKE_CXXFLAGS_RELEASE="$(shell dpkg-buildflags --get CPPFLAGS) $(shell dpkg-buildflags --get CFLAGS)" \
		QMAKE_CXXFLAGS_DEBUG="$(shell dpkg-buildflags --get CPPFLAGS) $(shell dpkg-buildflags --get CFLAGS)" \
		QMAKE_LFLAGS_RELEASE="$(shell dpkg-buildflags --get LDFLAGS)"  \
		QMAKE_LFLAGS_DEBUG="$(shell dpkg-buildflags --get LDFLAGS)" \
		MUDLET_VERSION_BUILD=$(BUILD_VERSION) \
		WITH_UPDATER="no"

override_dh_auto_build:
	make -C src

override_dh_install:
	dh_install
	chmod a-x debian/mudlet/usr/share/games/mudlet/lua/*.lua
	chmod a-x debian/mudlet/usr/share/games/mudlet/lua/geyser/*.lua

get-orig-source:
	rm -rf get-orig-source $(TARBALL)
	mkdir -p get-orig-source/$(PACKAGE)-$(SRC_VERSION).orig
	wget -O get-orig-source/upstream.tgz "http://mudlet.git.sourceforge.net/git/gitweb.cgi?p=mudlet/mudlet;a=snapshot;h=HEAD;sf=tgz"
	cd get-orig-source && tar xfz upstream.tgz -C $(PACKAGE)-$(SRC_VERSION).orig --strip-components=1
	cd get-orig-source/$(PACKAGE)-$(SRC_VERSION).orig/src && \
		rm -rf yajl fonts hunspell en_US.aff en_US.dic
	tar cvfz $(TARBALL) -C get-orig-source $(PACKAGE)-$(SRC_VERSION).orig
	rm -rf get-orig-source

=== debian/watch ===
version=4

https://www.mudlet.org/download/ Mudlet-(.*)\.tar\.xz debian uupdate
